Index: trunk/BNC/qwt/qwt_plot_legenditem.h
===================================================================
--- trunk/BNC/qwt/qwt_plot_legenditem.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_legenditem.h	(revision 9383)
@@ -24,17 +24,17 @@
   to have more space for the plot canvas.
 
-  In opposite to QwtLegend the legend item is not interactive. 
+  In opposite to QwtLegend the legend item is not interactive.
   To identify mouse clicks on a legend item an event filter
   needs to be installed catching mouse events ob the plot canvas.
   The geometries of the legend items are available using
   legendGeometries().
-  
-  The legend item is aligned to plot canvas according to 
+
+  The legend item is aligned to plot canvas according to
   its alignment() flags. It might have a background for the
   complete legend ( usually semi transparent ) or for
   each legend item.
 
-  \note An external QwtLegend with a transparent background 
-        on top the plot canvas might be another option 
+  \note An external QwtLegend with a transparent background
+        on top the plot canvas might be another option
         with a similar effect.
 */
@@ -46,5 +46,5 @@
       \brief Background mode
 
-      Depending on the mode the complete legend or each item 
+      Depending on the mode the complete legend or each item
       might have an background.
 
@@ -84,9 +84,9 @@
     void setItemSpacing( int );
     int itemSpacing() const;
-    
+
     void setFont( const QFont& );
     QFont font() const;
 
-    void setBorderDistance( int numPixels );
+    void setBorderDistance( int );
     int borderDistance() const;
 
@@ -106,7 +106,7 @@
     QPen textPen() const;
 
-    virtual void draw( QPainter *p,
+    virtual void draw( QPainter *,
         const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-        const QRectF &rect ) const;
+        const QRectF &canvasRect ) const;
 
     void clearLegend();
@@ -118,5 +118,5 @@
 
     virtual QSize minimumSize( const QwtLegendData & ) const;
-    virtual int heightForWidth( const QwtLegendData &, int w ) const;
+    virtual int heightForWidth( const QwtLegendData &, int width ) const;
 
     QList< const QwtPlotItem * > plotItems() const;
@@ -124,5 +124,5 @@
 
 protected:
-    virtual void drawLegendData( QPainter *painter, 
+    virtual void drawLegendData( QPainter *painter,
         const QwtPlotItem *, const QwtLegendData &, const QRectF & ) const;
 
Index: trunk/BNC/qwt/qwt_plot_marker.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot_marker.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_marker.cpp	(revision 9383)
@@ -135,5 +135,5 @@
     const QRectF &canvasRect ) const
 {
-    const QPointF pos( xMap.transform( d_data->xValue ), 
+    const QPointF pos( xMap.transform( d_data->xValue ),
         yMap.transform( d_data->yValue ) );
 
@@ -148,5 +148,5 @@
         const QSizeF sz = d_data->symbol->size();
 
-        const QRectF clipRect = canvasRect.adjusted( 
+        const QRectF clipRect = canvasRect.adjusted(
             -sz.width(), -sz.height(), sz.width(), sz.height() );
 
@@ -338,5 +338,5 @@
 /*!
   \brief Set the line style
-  \param style Line style. 
+  \param style Line style.
   \sa lineStyle()
 */
@@ -424,5 +424,5 @@
   In all other styles the alignment is relative to the marker's position.
 
-  \param align Alignment. 
+  \param align Alignment.
   \sa labelAlignment(), labelOrientation()
 */
@@ -503,19 +503,19 @@
 }
 
-/*! 
+/*!
   Build and assign a line pen
-    
+
   In Qt5 the default pen width is 1.0 ( 0.0 in Qt4 ) what makes it
   non cosmetic ( see QPen::isCosmetic() ). This method has been introduced
   to hide this incompatibility.
-    
+
   \param color Pen color
   \param width Pen width
   \param style Pen style
-    
+
   \sa pen(), brush()
- */ 
+ */
 void QwtPlotMarker::setLinePen( const QColor &color, qreal width, Qt::PenStyle style )
-{   
+{
     setLinePen( QPen( color, width, style ) );
 }
@@ -549,5 +549,17 @@
 QRectF QwtPlotMarker::boundingRect() const
 {
-    return QRectF( d_data->xValue, d_data->yValue, 0.0, 0.0 );
+    // width/height of -1 does not affect the autoscale calculation
+
+    switch (d_data->style)
+    {
+        case QwtPlotMarker::HLine:
+            return QRectF( d_data->xValue, d_data->yValue, -1.0, 0.0 );
+
+        case QwtPlotMarker::VLine:
+            return QRectF( d_data->xValue, d_data->yValue, 0.0, -1.0 );
+
+        default :
+            return QRectF( d_data->xValue, d_data->yValue, 0.0, 0.0 );
+    }
 }
 
@@ -555,5 +567,5 @@
    \return Icon representing the marker on the legend
 
-   \param index Index of the legend entry 
+   \param index Index of the legend entry
                 ( usually there is only one )
    \param size Icon size
@@ -586,5 +598,5 @@
             const double y = 0.5 * size.height();
 
-            QwtPainter::drawLine( &painter, 
+            QwtPainter::drawLine( &painter,
                 0.0, y, size.width(), y );
         }
@@ -595,5 +607,5 @@
             const double x = 0.5 * size.width();
 
-            QwtPainter::drawLine( &painter, 
+            QwtPainter::drawLine( &painter,
                 x, 0.0, x, size.height() );
         }
Index: trunk/BNC/qwt/qwt_plot_marker.h
===================================================================
--- trunk/BNC/qwt/qwt_plot_marker.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_marker.h	(revision 9383)
@@ -38,9 +38,9 @@
   line style. The alignment refers to the center point of
   the marker, which means, for example, that the label would be printed
-  left above the center point if the alignment was set to 
+  left above the center point if the alignment was set to
   Qt::AlignLeft | Qt::AlignTop.
 
   \note QwtPlotTextLabel is intended to align a text label
-        according to the geometry of canvas 
+        according to the geometry of canvas
         ( unrelated to plot coordinates )
 */
@@ -69,5 +69,5 @@
     };
 
-    explicit QwtPlotMarker( const QString &title = QString::null );
+    explicit QwtPlotMarker( const QString &title = QString() );
     explicit QwtPlotMarker( const QwtText &title );
 
@@ -85,9 +85,9 @@
     void setValue( const QPointF & );
 
-    void setLineStyle( LineStyle st );
+    void setLineStyle( LineStyle );
     LineStyle lineStyle() const;
 
     void setLinePen( const QColor &, qreal width = 0.0, Qt::PenStyle = Qt::SolidLine );
-    void setLinePen( const QPen &p );
+    void setLinePen( const QPen & );
     const QPen &linePen() const;
 
@@ -107,5 +107,5 @@
     int spacing() const;
 
-    virtual void draw( QPainter *p,
+    virtual void draw( QPainter *,
         const QwtScaleMap &xMap, const QwtScaleMap &yMap,
         const QRectF & ) const;
@@ -116,8 +116,8 @@
 
 protected:
-    virtual void drawLines( QPainter *, 
+    virtual void drawLines( QPainter *,
         const QRectF &, const QPointF & ) const;
 
-    virtual void drawLabel( QPainter *, 
+    virtual void drawLabel( QPainter *,
         const QRectF &, const QPointF & ) const;
 
Index: trunk/BNC/qwt/qwt_plot_multi_barchart.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot_multi_barchart.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_multi_barchart.cpp	(revision 9383)
@@ -109,17 +109,17 @@
 /*!
   Assign a series of samples
-    
+
   setSamples() is just a wrapper for setData() without any additional
   value - beside that it is easier to find for the developer.
-    
+
   \param data Data
   \warning The item takes ownership of the data object, deleting
            it when its not used anymore.
-*/  
-void QwtPlotMultiBarChart::setSamples( 
+*/
+void QwtPlotMultiBarChart::setSamples(
     QwtSeriesData<QwtSetSample> *data )
-{       
+{
     setData( data );
-}       
+}
 
 /*!
@@ -138,5 +138,5 @@
 }
 
-/*! 
+/*!
   \return Bar titles
   \sa setBarTitles(), legendData()
@@ -163,5 +163,5 @@
         return;
 
-    QMap<int, QwtColumnSymbol *>::iterator it = 
+    QMap<int, QwtColumnSymbol *>::iterator it =
         d_data->symbolMap.find(valueIndex);
     if ( it == d_data->symbolMap.end() )
@@ -207,7 +207,7 @@
 {
     QMap<int, QwtColumnSymbol *>::const_iterator it =
-        d_data->symbolMap.find( valueIndex );
-
-    return ( it == d_data->symbolMap.end() ) ? NULL : it.value();
+        d_data->symbolMap.constFind( valueIndex );
+
+    return ( it == d_data->symbolMap.constEnd() ) ? NULL : it.value();
 }
 
@@ -220,10 +220,10 @@
   \sa setSymbol(), specialSymbol(), drawBar()
 */
-QwtColumnSymbol *QwtPlotMultiBarChart::symbol( int valueIndex ) 
-{
-    QMap<int, QwtColumnSymbol *>::iterator it =
-        d_data->symbolMap.find( valueIndex );
-
-    return ( it == d_data->symbolMap.end() ) ? NULL : it.value();
+QwtColumnSymbol *QwtPlotMultiBarChart::symbol( int valueIndex )
+{
+    QMap<int, QwtColumnSymbol *>::const_iterator it =
+        d_data->symbolMap.constFind( valueIndex );
+
+    return ( it == d_data->symbolMap.constEnd() ) ? NULL : it.value();
 }
 
@@ -233,10 +233,5 @@
 void QwtPlotMultiBarChart::resetSymbolMap()
 {
-    for ( QMap<int, QwtColumnSymbol *>::iterator it 
-        = d_data->symbolMap.begin(); it != d_data->symbolMap.end(); ++it )
-    {
-        delete it.value();
-    }
-
+    qDeleteAll( d_data->symbolMap );
     d_data->symbolMap.clear();
 }
@@ -253,5 +248,5 @@
 
   When no symbol ( NULL ) is returned, the value will be displayed
-  with the standard symbol that is used for all symbols with the same 
+  with the standard symbol that is used for all symbols with the same
   valueIndex.
 
@@ -260,7 +255,7 @@
 
   \return NULL, meaning that the value is not special
-    
+
  */
-QwtColumnSymbol *QwtPlotMultiBarChart::specialSymbol( 
+QwtColumnSymbol *QwtPlotMultiBarChart::specialSymbol(
     int sampleIndex, int valueIndex ) const
 {
@@ -456,5 +451,5 @@
   \param index Index of the sample to be painted
   \param sampleWidth Boundng width for all bars of the smaple
-  \param sample Sample 
+  \param sample Sample
 
   \sa drawSeries(), sampleWidth()
@@ -536,5 +531,5 @@
   \param index Index of the sample to be painted
   \param sampleWidth Width of the bars
-  \param sample Sample 
+  \param sample Sample
 
   \sa drawSeries(), sampleWidth()
@@ -542,5 +537,5 @@
 void QwtPlotMultiBarChart::drawStackedBars( QPainter *painter,
     const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-    const QRectF &canvasRect, int index, 
+    const QRectF &canvasRect, int index,
     double sampleWidth, const QwtSetSample& sample ) const
 {
@@ -568,5 +563,4 @@
         double sum = baseline();
 
-        const int numBars = sample.set.size();
         for ( int i = 0; i < numBars; i++ )
         {
@@ -670,8 +664,8 @@
     {
         // we build a temporary default symbol
-        QwtColumnSymbol sym( QwtColumnSymbol::Box );
-        sym.setLineWidth( 1 );
-        sym.setFrameStyle( QwtColumnSymbol::Plain );
-        sym.draw( painter, rect );
+        QwtColumnSymbol columnSymbol( QwtColumnSymbol::Box );
+        columnSymbol.setLineWidth( 1 );
+        columnSymbol.setFrameStyle( QwtColumnSymbol::Plain );
+        columnSymbol.draw( painter, rect );
     }
 
@@ -702,5 +696,5 @@
         {
             QVariant iconValue;
-            qVariantSetValue( iconValue, 
+            qVariantSetValue( iconValue,
                 legendIcon( i, legendIconSize() ) );
 
@@ -719,5 +713,5 @@
   \param index Index of the bar
   \param size Icon size
-  
+
   \return An icon showing a bar
   \sa drawBar(), legendData()
Index: trunk/BNC/qwt/qwt_plot_multi_barchart.h
===================================================================
--- trunk/BNC/qwt/qwt_plot_multi_barchart.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_multi_barchart.h	(revision 9383)
@@ -20,7 +20,7 @@
 /*!
   \brief QwtPlotMultiBarChart displays a series of a samples that consist
-         each of a set of values. 
+         each of a set of values.
 
-  Each value is displayed as a bar, the bars of each set can be organized 
+  Each value is displayed as a bar, the bars of each set can be organized
   side by side or accumulated.
 
@@ -29,15 +29,15 @@
   by overloading specialSymbol() or overloading drawBar().
 
-  Depending on its orientation() the bars are displayed horizontally 
-  or vertically. The bars cover the interval between the baseline() 
+  Depending on its orientation() the bars are displayed horizontally
+  or vertically. The bars cover the interval between the baseline()
   and the value.
 
   In opposite to most other plot items, QwtPlotMultiBarChart returns more
   than one entry for the legend - one for each symbol.
-   
+
   \sa QwtPlotBarChart, QwtPlotHistogram
       QwtPlotSeriesItem::orientation(), QwtPlotAbstractBarChart::baseline()
  */
-class QWT_EXPORT QwtPlotMultiBarChart: 
+class QWT_EXPORT QwtPlotMultiBarChart:
     public QwtPlotAbstractBarChart, public QwtSeriesStore<QwtSetSample>
 {
@@ -62,5 +62,5 @@
     };
 
-    explicit QwtPlotMultiBarChart( const QString &title = QString::null );
+    explicit QwtPlotMultiBarChart( const QString &title = QString() );
     explicit QwtPlotMultiBarChart( const QwtText &title );
 
@@ -79,6 +79,6 @@
     ChartStyle style() const;
 
-    void setSymbol( int barIndex, QwtColumnSymbol *symbol );
-    const QwtColumnSymbol *symbol( int barIndex ) const;
+    void setSymbol( int valueIndex, QwtColumnSymbol * );
+    const QwtColumnSymbol *symbol( int valueIndex ) const;
 
     void resetSymbolMap();
@@ -95,7 +95,7 @@
 
 protected:
-    QwtColumnSymbol *symbol( int barIndex );
+    QwtColumnSymbol *symbol( int valueIndex );
 
-    virtual QwtColumnSymbol *specialSymbol( 
+    virtual QwtColumnSymbol *specialSymbol(
         int sampleIndex, int valueIndex ) const;
 
@@ -106,5 +106,5 @@
 
     virtual void drawBar( QPainter *, int sampleIndex,
-        int barIndex, const QwtColumnRect & ) const;
+        int valueIndex, const QwtColumnRect & ) const;
 
     void drawStackedBars( QPainter *painter,
Index: trunk/BNC/qwt/qwt_plot_panner.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot_panner.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_panner.cpp	(revision 9383)
@@ -15,12 +15,33 @@
 #include <qstyle.h>
 #include <qstyleoption.h>
+#include <qpainterpath.h>
+
+#if QT_VERSION >= 0x050000
+#if QT_VERSION < 0x050100
+#define QWT_USE_WINDOW_HANDLE 1
+#endif
+#endif
+
+#ifdef QWT_USE_WINDOW_HANDLE
+#include <qwindow.h>
+#endif
 
 static QBitmap qwtBorderMask( const QWidget *canvas, const QSize &size )
 {
+#if QT_VERSION >= 0x050000
+    qreal pixelRatio = 1.0;
+
+#ifdef QWT_USE_WINDOW_HANDLE
+    pixelRatio = canvas->windowHandle()->devicePixelRatio();
+#else
+    pixelRatio = canvas->devicePixelRatio();
+#endif
+#endif
+
     const QRect r( 0, 0, size.width(), size.height() );
 
     QPainterPath borderPath;
 
-    ( void )QMetaObject::invokeMethod( 
+    ( void )QMetaObject::invokeMethod(
         const_cast< QWidget *>( canvas ), "borderPath", Qt::DirectConnection,
         Q_RETURN_ARG( QPainterPath, borderPath ), Q_ARG( QRect, r ) );
@@ -31,5 +52,10 @@
             return QBitmap();
 
+#if QT_VERSION >= 0x050000
+        QBitmap mask( size * pixelRatio );
+        mask.setDevicePixelRatio( pixelRatio );
+#else
         QBitmap mask( size );
+#endif
         mask.fill( Qt::color0 );
 
@@ -40,5 +66,10 @@
     }
 
+#if QT_VERSION >= 0x050000
+    QImage image( size * pixelRatio, QImage::Format_ARGB32_Premultiplied );
+    image.setDevicePixelRatio( pixelRatio );
+#else
     QImage image( size, QImage::Format_ARGB32_Premultiplied );
+#endif
     image.fill( Qt::color0 );
 
@@ -63,10 +94,10 @@
         const QVariant frameWidth = canvas->property( "frameWidth" );
 
-        if ( borderRadius.type() == QVariant::Double 
+        if ( borderRadius.type() == QVariant::Double
             && frameWidth.type() == QVariant::Int )
         {
             const double br = borderRadius.toDouble();
             const int fw = frameWidth.toInt();
-        
+
             if ( br > 0.0 && fw > 0 )
             {
@@ -114,6 +145,6 @@
     d_data = new PrivateData();
 
-    connect( this, SIGNAL( panned( int, int ) ),
-        SLOT( moveCanvas( int, int ) ) );
+    connect( this, SIGNAL(panned(int,int)),
+        SLOT(moveCanvas(int,int)) );
 }
 
@@ -256,5 +287,5 @@
  */
 QPixmap QwtPlotPanner::grab() const
-{   
+{
     const QWidget *cv = canvas();
     if ( cv && cv->inherits( "QGLWidget" ) )
@@ -272,4 +303,4 @@
 
     return QwtPanner::grab();
-}   
-
+}
+
Index: trunk/BNC/qwt/qwt_plot_picker.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot_picker.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_picker.cpp	(revision 9383)
@@ -193,4 +193,7 @@
 QwtText QwtPlotPicker::trackerText( const QPoint &pos ) const
 {
+    if ( plot() == NULL )
+        return QwtText();
+
     return trackerTextF( invTransform( pos ) );
 }
Index: trunk/BNC/qwt/qwt_plot_rasteritem.cpp
===================================================================
--- trunk/BNC/qwt/qwt_plot_rasteritem.cpp	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_rasteritem.cpp	(revision 9383)
@@ -159,5 +159,7 @@
     py0 += strippedRect.top() - paintRect.top();
 
-    QImage expanded(sz, image.format());
+    QImage expanded( sz, image.format() );
+    if ( image.format() == QImage::Format_Indexed8 )
+        expanded.setColorTable( image.colorTable() );
 
     switch( image.depth() )
@@ -191,5 +193,5 @@
                 }
 
-                const quint32 *line1 = 
+                const quint32 *line1 =
                     reinterpret_cast<const quint32 *>( image.scanLine( y1 ) );
 
@@ -223,12 +225,12 @@
                     for ( int y2 = yy1; y2 < yy2; y2++ )
                     {
-                        quint32 *line2 = reinterpret_cast<quint32 *>( 
+                        quint32 *line2 = reinterpret_cast<quint32 *>(
                             expanded.scanLine( y2 ) );
 
-                        for ( int x2 = xx1; x2 < xx2; x2++ ) 
+                        for ( int x2 = xx1; x2 < xx2; x2++ )
                             line2[x2] = rgb;
-                    }       
-                }   
-            }   
+                    }
+                }
+            }
             break;
         }
@@ -241,17 +243,17 @@
                 {
                     yy1 = 0;
-                }   
+                }
                 else
                 {
                     yy1 = qRound( y1 * ph - py0 );
                     if ( yy1 < 0 )
-                        yy1 = 0; 
-                }       
-                
+                        yy1 = 0;
+                }
+
                 int yy2;
                 if ( y1 == h - 1 )
                 {
                     yy2 = sz.height();
-                }   
+                }
                 else
                 {
@@ -260,5 +262,5 @@
                         yy2 = sz.height();
                 }
-    
+
                 const uchar *line1 = image.scanLine( y1 );
 
@@ -293,6 +295,6 @@
                         uchar *line2 = expanded.scanLine( y2 );
                         memset( line2 + xx1, line1[x1], xx2 - xx1 );
-                    }       
-                }   
+                    }
+                }
             }
             break;
@@ -301,7 +303,7 @@
             expanded = image;
     }
-    
+
     return expanded;
-}   
+}
 
 static QRectF qwtExpandToPixels(const QRectF &rect, const QRectF &pixelRect)
@@ -385,5 +387,5 @@
 }
 
-static void qwtToRgba( const QImage* from, QImage* to,  
+static void qwtToRgba( const QImage* from, QImage* to,
     const QRect& tile, int alpha )
 {
@@ -573,14 +575,14 @@
 
    The geometry of a pixel is used to calculated the resolution and
-   alignment of the rendered image. 
-
-   Width and height of the hint need to be the horizontal  
-   and vertical distances between 2 neighbored points. 
-   The center of the hint has to be the position of any point 
+   alignment of the rendered image.
+
+   Width and height of the hint need to be the horizontal
+   and vertical distances between 2 neighbored points.
+   The center of the hint has to be the position of any point
    ( it doesn't matter which one ).
 
    Limiting the resolution of the image might significantly improve
    the performance and heavily reduce the amount of memory when rendering
-   a QImage from the raster data. 
+   a QImage from the raster data.
 
    The default implementation returns an empty rectangle (QRectF()),
@@ -664,5 +666,5 @@
         {
             /*
-              If only one dimension is of the data pixel is higher 
+              If only one dimension is of the data pixel is higher
               we expand the pixel rect to the resolution of the target device.
              */
@@ -690,5 +692,5 @@
         // data pixels we render in resolution of the paint device.
 
-        image = compose(xxMap, yyMap, 
+        image = compose(xxMap, yyMap,
             area, paintRect, paintRect.size().toSize(), doCache);
         if ( image.isNull() )
@@ -698,17 +700,17 @@
         // excluded in the intervals
 
-        imageRect = qwtStripRect(paintRect, area, 
+        imageRect = qwtStripRect(paintRect, area,
             xxMap, yyMap, xInterval, yInterval);
 
         if ( imageRect != paintRect )
         {
-            const QRect r( 
+            const QRect r(
                 qRound( imageRect.x() - paintRect.x()),
                 qRound( imageRect.y() - paintRect.y() ),
                 qRound( imageRect.width() ),
                 qRound( imageRect.height() ) );
-                
+
             image = image.copy(r);
-        }   
+        }
     }
     else
@@ -735,5 +737,5 @@
         imageSize.setHeight( qRound( imageArea.height() / pixelRect.height() ) );
 
-        image = compose(xxMap, yyMap, 
+        image = compose(xxMap, yyMap,
             imageArea, paintRect, imageSize, doCache );
 
@@ -741,5 +743,5 @@
             return;
 
-        imageRect = qwtStripRect(paintRect, area, 
+        imageRect = qwtStripRect(paintRect, area,
             xxMap, yyMap, xInterval, yInterval);
 
@@ -747,9 +749,9 @@
             testPaintAttribute( PaintInDeviceResolution ) )
         {
-            // Because of rounding errors the pixels 
-            // need to be expanded manually to rectangles of 
+            // Because of rounding errors the pixels
+            // need to be expanded manually to rectangles of
             // different sizes
 
-            image = qwtExpandImage(image, xxMap, yyMap, 
+            image = qwtExpandImage(image, xxMap, yyMap,
                 imageArea, area, paintRect, xInterval, yInterval );
         }
@@ -758,5 +760,5 @@
     painter->save();
     painter->setWorldTransform( QTransform() );
-    
+
     QwtPainter::drawImage( painter, imageRect, image );
 
@@ -769,5 +771,5 @@
    This method is intended to be reimplemented by derived classes.
    The default implementation returns an invalid interval.
-   
+
    \param axis X, Y, or Z axis
 */
@@ -817,7 +819,7 @@
 }
 
-QImage QwtPlotRasterItem::compose( 
+QImage QwtPlotRasterItem::compose(
     const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-    const QRectF &imageArea, const QRectF &paintRect, 
+    const QRectF &imageArea, const QRectF &paintRect,
     const QSize &imageSize, bool doCache) const
 {
@@ -842,12 +844,12 @@
             dx = imageArea.width() / imageSize.width();
 
-        const QwtScaleMap xxMap = 
+        const QwtScaleMap xxMap =
             imageMap(Qt::Horizontal, xMap, imageArea, imageSize, dx);
-        
+
         double dy = 0.0;
         if ( paintRect.toRect().height() > imageSize.height() )
             dy = imageArea.height() / imageSize.height();
 
-        const QwtScaleMap yyMap = 
+        const QwtScaleMap yyMap =
             imageMap(Qt::Vertical, yMap, imageArea, imageSize, dy);
 
@@ -937,5 +939,5 @@
     }
 
-    if ( pixelSize > 0.0 )
+    if ( pixelSize > 0.0 || p2 == 1.0 )
     {
         double off = 0.5 * pixelSize;
Index: trunk/BNC/qwt/qwt_plot_rasteritem.h
===================================================================
--- trunk/BNC/qwt/qwt_plot_rasteritem.h	(revision 8127)
+++ trunk/BNC/qwt/qwt_plot_rasteritem.h	(revision 9383)
@@ -51,8 +51,8 @@
         /*!
           renderImage() is called, whenever the image cache is not valid,
-          or the scales, or the size of the canvas has changed. 
+          or the scales, or the size of the canvas has changed.
 
-          This type of cache is useful for improving the performance 
-          of hide/show operations or manipulations of the alpha value. 
+          This type of cache is useful for improving the performance
+          of hide/show operations or manipulations of the alpha value.
           All other situations are handled by the canvas backing store.
          */
@@ -69,9 +69,9 @@
           When the image is rendered according to the data pixels
           ( QwtRasterData::pixelHint() ) it can be expanded to paint
-          device resolution before it is passed to QPainter. 
-          The expansion algorithm rounds the pixel borders in the same 
+          device resolution before it is passed to QPainter.
+          The expansion algorithm rounds the pixel borders in the same
           way as the axis ticks, what is usually better than the
           scaling algorithm implemented in Qt.
-          Disabling this flag might make sense, to reduce the size of a 
+          Disabling this flag might make sense, to reduce the size of a
           document/file. If this is possible for a document format
           depends on the implementation of the specific QPaintEngine.
@@ -84,5 +84,5 @@
     typedef QFlags<PaintAttribute> PaintAttributes;
 
-    explicit QwtPlotRasterItem( const QString& title = QString::null );
+    explicit QwtPlotRasterItem( const QString& title = QString() );
     explicit QwtPlotRasterItem( const QwtText& title );
     virtual ~QwtPlotRasterItem();
@@ -99,7 +99,7 @@
     void invalidateCache();
 
-    virtual void draw( QPainter *p,
+    virtual void draw( QPainter *,
         const QwtScaleMap &xMap, const QwtScaleMap &yMap,
-        const QRectF &rect ) const;
+        const QRectF &canvasRect ) const;
 
     virtual QRectF pixelHint( const QRectF & ) const;
@@ -110,8 +110,8 @@
 protected:
     /*!
-      \brief Render an image 
+      \brief Render an image
 
       An implementation of render() might iterate over all
-      pixels of imageRect. Each pixel has to be translated into 
+      pixels of imageRect. Each pixel has to be translated into
       the corresponding position in scale coordinates using the maps.
       This position can be used to look up a value in a implementation
@@ -122,5 +122,5 @@
       \param area Requested area for the image in scale coordinates
       \param imageSize Requested size of the image
-   
+
       \return Rendered image
      */
